{% extends "baseAjaxTable.html" %}
{% block style %}
<link rel="stylesheet" href="{{ url_for("static", filename="css/styleDataTable.css")}}">
{% endblock %}
{% block content %}
{{ super() }}

<button  data-toggle="modal" class="btn btn-danger btn-del" data-target="#modalSupprimer">Supprimer la ligne</button>
<button type="button" data-target="#ModalCoursForm" class="btn btn-secondary btn-add" data-toggle="modal" >Ajouter un Cours</button>
<button type="button" class="btn btn-secondary btn-edit" data-toggle="modal" data-target="#ModalModifCoursForm"> Modifier le Cours</button>
<button type="button" id="btn-filtre" class="btn btn-secondary" data-toggle="modal" data-target="#ModalCoursFormFiltre"> Filtrer</button>


  <table id="data" class="table table-striped display table-bordered">
    <thead>
      <tr>
        <th>ID Cours</th>
        <th>Nom Cours</th>
        <th>Nom Moniteur</th>
        <th>Jours Semaine </th>
        <th>Heure debut</th>
        <th>Durée</th>
        <th>Type Cours</th>
        <th>Desc Cours</th>
        <th>ID Moniteur</th>
      </tr>
    </thead>
    <tbody>

    </tbody>
  </table>
  <!--Modal s'affichant lors du clique de supprimer pour savoir si on veut vraiment supprimer-->
  <div class="modal fade" id="modalSupprimer" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Supprimer</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <p>Etes-vous sur de vouloir supprimer ce Cours ?</p>
          <span id="courssup"></span>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
          <button type="button" class="btn btn-danger" id="deleteCours" data-dismiss="modal">Supprimer</button>
          
        </div>
      </div>
    </div>
</div>

<div id="ModalCoursForm" class="modal fade modal-cours" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Ajouter un Cours</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{  url_for("save_cours") }}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="submit" class="btn btn-primary" value="Ajouter">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->
 

<div id="ModalModifCoursForm" class="modal fade modal-cours" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Modifier le Cours</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{  url_for("edit_cours") }}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% elif form[field].type == 'BooleanField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} "">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="submit" class="btn btn-primary" value="Modifier">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->

<div id="ModalCoursFormFiltre" class="modal fade modal-cours" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Filtrer</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST">
                {{ form.hidden_tag() }}
                {% for field in form_filtre.get_form_field() %}
                    {% if form_filtre[field].type == 'SelectField' %}
                      <div class="form-group{% if form_filtre[field].errors %} has-error{% endif %}">
                        {{ form_filtre[field].label }} {{ form_filtre[field](size=1) }}
                      </div>
                    {% else %}
                      <div class="form-group{% if form_filtre[field].errors %} has-error{% endif %}">
                            {{ form_filtre[field].label }} {{ form_filtre[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form_filtre[field].errors %}
                        <ul class="list-group">
                            {% for e in form_filtre[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <button type="button" id="btn-filtre-save" class="btn btn-secondary" data-toggle="modal" data-target="#ModalCoursFormFiltre"> Filtrer</button>
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->


{% endblock %}

{% block scripts %}
  <script>
    let row = null;
    $(document).ready(function(){
      let open_modal = '{{open_modal}}';
      if (open_modal) {
        $('#ModalCoursForm').modal('show');
      }
      let open_modal_edit = '{{open_modal_edit}}';
      if (open_modal_edit) {
        $('#ModalModifCoursForm').modal('show');
      }
      $(".btn-edit").prop("disabled",true);
      $(".btn-del").prop("disabled",true);
      let table = $('#data').DataTable({
        ajax:{
              url:'/api/data/cours',
                type:"POST",
                data:function(cou){
                    if(cou!=undefined){
                      cou.nom_cours_filtre = $("#nom_cours_filtre").val();
                      cou.type_cours_filtre = $("#type_cours_filtre").val();
                      cou.jours_semaine_filtre = $("#jours_semaine_filtre").val();
                      cou.heure_debut_cours_filtre = $("#heure_debut_cours_filtre").val();
                      cou.duree_cours_filtre = $("#duree_cours_filtre").val();
                      cou.prenom_moniteur_filtre = $("#prenom_moniteur_filtre").val();
                  }
                  return cou
                }
        },
        
        columns: [
          {data: 'idc'},
          {data: 'nomc', searchable: true},
          {data: 'prenom_nom_moniteur', searchable: true, orderable:true},
          {data: 'jours_semaine', searchable: true},
          {data: 'heure_debut', searchable: true},
          {data: 'duree', searchable: true},
          {data: 'typec', searchable: true},
          {data: 'descc', searchable: false},
          {data: 'id_moniteur', searchable: false, orderable:false}
        ],
      
        
        });
        $("#prenom_moniteur").prop("disabled",true);
        $("#jours_semaine, #heure_debut_cours, #duree_cours").change(function() {
        let selectedValueJours = $("#jours_semaine").val();
        let selectedValueHeureDebut = $("#heure_debut_cours").val();
        let selectedValueDuree = $("#duree_cours").val();
        if(selectedValueHeureDebut != "" && selectedValueDuree != ""){
          $("#prenom_moniteur").prop("disabled",false);
          // ici vous pouvez utiliser la valeur sélectionnée pour mettre à jour les options du deuxième Select Field
          // par exemple en utilisant une requête AJAX pour récupérer les nouvelles options depuis un serveur
          $.ajax({
            url: '/update_moniteur_options',
            type: 'POST',
            data: {'jours_semaine': selectedValueJours, 'heure_debut':selectedValueHeureDebut, 'duree':selectedValueDuree},
            success: function(response) {
                let options = "";
                response.forEach(moniteur => {
                  options += `<option value=${moniteur.id}>id ${moniteur.id}: ${moniteur.prenom} ${moniteur.nom}</option>`;

                });
                $("#prenom_moniteur").html(options);
            },
            error: function(error) {
              console.log(error);
            }
          });
        }
        else{
          $("#prenom_moniteur").prop("disabled",true);
        }
      });

        $('#ModalModifCoursForm input, #ModalModifCoursForm select, #ModalModifCoursForm textarea').each(function(){
            let currentId = $(this).attr('id');
            $(this).attr('id', currentId + '_modif');
        });


       $("#data").on("click", "tr", function() {
            if(row !=null){
                $(row).css('background-color', "");     
            }
            $("#buttonSupr").prop("disabled",false)
            row = this;
            $(".btn-edit").prop("disabled",false);
            $(".btn-del").prop("disabled",false);
            console.log(((row)));
            $(this).css('background-color', "#AFE1AF");
            $("#courssupprimer").html($(row)[0].childNodes[1].innerHTML+ " " + $(row)[0].childNodes[2].innerHTML)
        });

        $("#deleteCours").on("click",function(){
            $.ajax({
                url:'{{url_for("delete_cours")}}',
                type:'POST',
                data:{id:$(row)[0].childNodes[0].innerHTML},
            success: function(){
                table.ajax.reload();
                } 
            });       
        });

        $('#ModalCoursForm #prenom_moniteur').select2({  // init Select2 on form's name field
          dropdownParent: $('#ModalCoursForm'),
          placeholder: "{{ form.prenom_moniteur.label.text }}",
          allowClear: true,
          "width": "style"
        });

        $('#ModalModifCoursForm #prenom_moniteur_modif').select2({  // init Select2 on form's name field
          dropdownParent: $('#ModalModifCoursForm'),
          placeholder: "{{ form.prenom_moniteur.label.text }}",
          allowClear: true,
          "width": "style"
        });

        $("#data").on("dblclick", "tr", function() {
          row = this;
          let idCour = row.childNodes[0].innerHTML;
          window.location.href = "{{ url_for('detail_cour', id='idCour') }}".replace("idCour",idCour) ;
        });
     
        $(document).on('click', '.btn-edit', function() {
          // On récuperer les heures dans les input de type time et on les convertie dans le bon format.

          let heure_minute_debut = ($(row)[0].childNodes[4].innerHTML.split("h"));
          if(heure_minute_debut[0].length == 1){
            heure_minute_debut[0] = "0"+ heure_minute_debut[0];
          }
          if(heure_minute_debut[1].length == 1){
            heure_minute_debut[1] += "0";
          }
          let heure_minute_duree = ($(row)[0].childNodes[5].innerHTML.replace("min","").split("h"));
          if(heure_minute_duree[0].length == 1){
            heure_minute_duree[0] = "0"+ heure_minute_duree[0];
          }
          if(heure_minute_duree[1].length == 1){
            heure_minute_duree[1] += "0";
          }

          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation


          $('#ModalModifCoursForm #id_c_modif').val($(row)[0].childNodes[0].innerHTML);
          $('#ModalModifCoursForm #nom_cours_modif').val($(row)[0].childNodes[1].innerHTML);
          $('#ModalModifCoursForm #description_cours_modif').val($(row)[0].childNodes[7].innerHTML);
          $('#ModalModifCoursForm #type_cours_modif').val($(row)[0].childNodes[6].innerHTML);
          $('#ModalModifCoursForm #jours_semaine_modif').val($(row)[0].childNodes[3].innerHTML);
          $('#ModalModifCoursForm #heure_debut_cours_modif').val(heure_minute_debut.join(":"));
          $('#ModalModifCoursForm #duree_cours_modif').val(heure_minute_duree.join(":"));
          $('#ModalModifCoursForm #prenom_moniteur_modif').val($(row)[0].childNodes[8].innerHTML);
          // Afficher le modal
          $('#ModalModifCoursForm').modal('show');
        });

        $(document).on('click', '.btn-add', function() {
          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation
          $('#ModalCoursForm #id_c').val();
          $('#ModalCoursForm #nom_cours').val();
          $('#ModalCoursForm #description_cours').val();
          $('#ModalCoursForm #type_cours').val();
          $('#ModalCoursForm #jours_semaine').val();
          $('#ModalCoursForm #heure_debut_cours').val();
          $('#ModalCoursForm #duree_cours').val();
          $('#ModalCoursForm #prenom_moniteur').val();
          // Afficher le modal
          $('#ModalCoursForm').modal('show');

          let errorElements = document.getElementsByClassName("list-group-item-danger");

          // Loop through the elements and remove the li element
          while(errorElements.length > 0){
            errorElements[0].parentNode.removeChild(errorElements[0]);
          }
          
        });

        $("#btn-filtre-save").on("click",function(){
          table.ajax.reload();
          $("#ModalPoneyFormFiltre").modal("hide");
        });
        $("#btn-filtre").on("click",function(){
            $("#ModalPoneyFormFiltre").modal("show");
        });


    });




   
 



    
  </script>
{% endblock %}
<!--
  https://datatables.net/examples/api/select_single_row.html
  https://blog.miguelgrinberg.com/post/beautiful-interactive-tables-for-your-flask-templates-->